##################################
# Ne pas modifier la suite sans precaution
##################################

# monimage_gris(T,elarg,ehaut,egris) sauvegarde un fichier .pnm
# monTrait_image_NB(T,S,ehaut,elarg) affiche une image
##################################
# Chargement de l'image en niveaux de gris
##################################
from tkinter import *

def ouvrir_image_gris():
    print('ouverture fichier image')
    nom=input('nom (avec extension):')
    filin = open(nom,'r')
    mode = filin.readline()
    print('mode:', mode)
    # Largeur de l'image
    elar = filin.readline()
    elarg = int(elar)
    print('largeur:', elarg)
    # Hauteur de l'image
    ehau = filin.readline()
    ehaut = int(ehau)
    print('hauteur:', ehaut)
    # Niveaux de gris
    egri = filin.readline()
    egris = int(egri)
    print('niveaux de gris:', egris)
    ##################################
    # Initialisation de la matrice Sortie vide
    ##################################
    print('creation matrice vide')
    E=[]
    for i in range(ehaut):
        sl = []
        for j in range(elarg):
            sl.append(0)
        E.append(sl)
    ##################################
    # Creation de la matrice Image
    ##################################
    print('creation matrice image')
    borne=0
    for i in range(ehaut):
        for j in range(elarg):
            drap=0
            pixel=''
            rep=[]
            borne=borne+1
            while (drap==0 and borne < ehaut*elarg):
                car=filin.read(1)
                if (car==' ' or car =='\n'):
                    drap=0
                else:
                    drap=1
                    pixel=pixel+car
                    while drap==1:
                        car=filin.read(1)
                        if (car==' ' or car =='\n'):
                            drap=2
                            E[i][j]=int(pixel)
                        else:
                            pixel=pixel+car
    filin.close()
    return (E,elarg,ehaut,egri)

##################################
# Chargement de l'image Noir et Blanc
##################################
def ouvrir_image_NB():
    print('ouverture fichier image')
    nom=input('nom (avec extension):')
    filin = open(nom,'r')
    mode = filin.readline()
    print('mode:', mode)
    # Largeur de l'image
    elar = filin.readline()
    elarg = int(elar)
    print('largeur:', elarg)
    # Hauteur de l'image
    ehau = filin.readline()
    ehaut = int(ehau)
    print('hauteur:', ehaut)
    ##################################
    # Initialisation de la matrice Sortie vide
    ##################################
    print('creation matrice vide')
    E=[]
    for i in range(ehaut):
        sl = []
        for j in range(elarg):
            sl.append(0)
        E.append(sl)
    ##################################
    # Creation de la matrice Image
    ##################################
    print('creation matrice image')
    borne=0
    for i in range(ehaut):
        for j in range(elarg):
            drap=0
            pixel=''
            rep=[]
            borne=borne+1
            while (drap==0 and borne < ehaut*elarg):
                car=filin.read(1)
                if (car=='0' or car =='1'):
                    E[i][j]=int(car)
                    drap=1
    filin.close()
    return (E,elarg,ehaut)

##################################
# Initialisation de la matrice Sortie vide
##################################
def matrice_sortie(elarg,ehaut):
    T=[]
    for i in range(int(ehaut)):
        sl = []
        for j in range(int(elarg)):
            sl.append(0)
        T.append(sl)
    return T

##################################
# Creation du fichier monimage.txt
##################################
def monimage_gris(T,elarg,ehaut,egris):
    filout = open('monimage.pnm','w')
    filout.write('P2\n')
    filout.write(elarg+'\n')
    filout.write(ehaut+'\n')
    filout.write(egris+'\n')
    for i in range(int(ehaut)):
        t = ''
        for j in range(int(elarg)):
            t =  t + str(T[i][j])
            t =  t + ' '
        t =  t + '\n'
        filout.write(t)
    filout.close()


def monimage_NB(T,elarg,ehaut):
    filout = open('monimage.pbm','w')
    filout.write('P1\n')
    filout.write(elarg+'\n')
    filout.write(ehaut+'\n')
    for i in range(int(ehaut)):
        t = ''
        for j in range(int(elarg)):
            t =  t + str(T[i][j])
            t =  t + ' '
        t =  t + '\n'
        filout.write(t)
    filout.close()

from tkinter import *
##################################
#Fichier de l'image a traiter
##################################
filin = open('testNB.txt','r')
##################################
#ENTREE: ne pas modifier
##################################
def pixel(x,y,canevas):
    canevas.create_rectangle(x, y, x+10, y+10, fill ='black')
def pixelr(x,y,canevas):
    canevas.create_rectangle(x, y, x+10, y+10, fill ='red')

def monTrait_image_NB(T,S,ehaut,elarg):
    fen = Tk()
    can = Canvas(fen, width =800, height =600, bg ='white')
    can.pack(side =TOP, padx =5, pady =5)

    for i in range(ehaut+1):
        pixelr(0,10*i,can)
        pixelr(10*(elarg+1),10*i,can)
        pixelr(10*(2*elarg+2),10*i ,can)
        
    for i in range(3+2*elarg):
        pixelr(10*i,10*(ehaut+1),can)
        pixelr(10*i,0,can)

    for i in range(ehaut):
        for j in range(elarg):
            if S[i][j]==1:
                pixel(10*(j+2+elarg),10*(i+1),can)
            if T[i][j]==1:
                pixel(10*(j+1),10*(i+1),can)
    fen.mainloop()
    input('pour quitter, appuyer sur une touche')

def pixel_HD(x,y,canevas):
    canevas.create_rectangle(x, y, x+1, y+1, fill ='black')
def pixelr_HD(x,y,canevas):
    canevas.create_rectangle(x, y, x+1, y+1, fill ='red')


def monTrait_image_NB_HD(T,S,ehaut,elarg):
    fen = Tk()
    can = Canvas(fen, width =800, height =600, bg ='white')
    can.pack(side =TOP, padx =5, pady =5)

    for i in range(ehaut+1):
        pixelr(0,i,can)
        pixelr(elarg+1,i,can)
        pixelr(2*elarg+2,i ,can)
        
    for i in range(3+2*elarg):
        pixelr(i,ehaut+1,can)
        pixelr(i,0,can)

    for i in range(ehaut):
        for j in range(elarg):
            if S[i][j]==1:
                pixel(j+2+elarg,i+1,can)
            if T[i][j]==1:
                pixel(j+1,i+1,can)
    fen.mainloop()
    input('pour quitter, appuyer sur une touche')


